// -*-C++-*-
/*!
 * @file  LRFProcessSVC_impl.cpp
 * @brief Service implementation code of LRFProcess.idl
 *
 */

#include "LRFProcessSVC_impl.h"
#include <iostream>
#include <math.h>
#include "timer.h"
using namespace std;

extern	double goal_urg_x;//on mouse
extern double goal_urg_y;//on mouse
extern	bool id_flag;
static const double SizeMax=0.02;
static const double SizeMin=0.00001;
static const int LostTime=500;
static const double LENGTH=0.5;
static const double OBSTACLE_AREA=0.5;
/*
 * Example implementational code for IDL interface LRFTracking
 */
LRFTrackingSVC_impl::LRFTrackingSVC_impl()
{
  // Please add extra constructor code here.
}


LRFTrackingSVC_impl::~LRFTrackingSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Short LRFTrackingSVC_impl::setHumanPos(CORBA::Double x, CORBA::Double y)
{
	 target_x=x;
	 target_y=y;
}

CORBA::Short LRFTrackingSVC_impl::getHumanPos(CORBA::Double& x, CORBA::Double& y)
{
	 x=target_x;
	 y=target_y;

}
// End of example implementational code

void LRFTrackingSVC_impl::discriminant(double vision_x,double vision_y,double &object_x,double &object_y){
 
    static double old_vision_x,old_vision_y;
	static bool LRF_flag=1;
	//見失っていて、カメラから見えれば発見開始。
    if((vision_x!=0)&&(vision_y!=0)&&(LRF_flag==0)){	
		if((vision_x!=old_vision_x)||(vision_y!=old_vision_y)){
			goal_urg_x=vision_x;
			goal_urg_y=vision_y;
			target_x=vision_x;
			target_y=vision_y;
			LRF_flag=1;
	    }
 	old_vision_x=vision_x;
	old_vision_y=vision_y;   
    }

   detection();

    double urg_x=goal_urg_x;
    double urg_y=goal_urg_y; 

    static double old_x;
    static double old_y;

	static int time=0;
	static long int sum_time=0;
	static double now_t=0,start_t=0;
 	static double old_t=0;

    if((old_x==goal_urg_x)&&(old_y==goal_urg_y)){


	LRF_flag=1;
   now_t=timer_ms();
	if(old_t!=0)	time=(now_t-old_t);
	if(time>0) sum_time+=time;
   old_t=timer_ms();

   }
    else{
	now_t=0;
	start_t=0;
	old_t=0;
	sum_time=0;
    }

    object_x=urg_x;
    object_y=urg_y;

	//cout<<sum_time<<endl;
   if(sum_time>LostTime){
	urg_x=0;
	urg_y=0;
    object_x=0.0;
    object_y=0.0;
	LRF_flag=0;
	cout<<"Lost"<<endl;
	//return;
    }
	else{
	cout<<"Tracking Success"<<endl;
	}

	old_x=goal_urg_x;
    old_y=goal_urg_y;

	return;
}

void LRFTrackingSVC_impl::detection(){



    int i,j;
	double CYCLE=2*PI/lrf_resolusion;
	double ZeroPos=lrf_offset/(2*PI)*CYCLE-CYCLE/4.0;

    for(i=0;i<lrf_scanpoint;i++){
	if(distance[i]<30) {
	    distance[i]=0;
	}
	urg[i].num=i;
	urg[i].r=(double)distance[i]/1000.0;
	urg[i].thita=2*PI*(double)(i+ZeroPos)/CYCLE;
	urg[i].x=point_x[i];
	urg[i].y=point_y[i];
    }


    double x,y,r;		
    for(i=0;i<lrf_scanpoint;i++){
	points[i].ptnum=0;
	points[i].dis=0;
	points[i].flag=0;
	points[i].flag2=1;
    }
	
    
    int ptnum;
    int clnum;
      
    ptnum=0;
    clnum=0;
    clend=0;
      
    for(i=0;i<lrf_scanpoint;i++){
	if(((fabs( urg[i+1].r-urg[i].r )< urg[i].r*0.05)||(fabs( urg[i+1].r-urg[i].r )< 0.05))&&(urg[i].x!=0)&&(urg[i].y!=0)){
	   
	    points[clnum].r[ptnum]=urg[i].r;
	    points[clnum].thita[ptnum]=urg[i].thita;
	    points[clnum].x[ptnum]=urg[i].x;
	    points[clnum].y[ptnum]=urg[i].y;
	    points[clnum].ptnum=ptnum;
	    ptnum++;
	}
	
	else if(urg[i+1].r==0){
	    if((fabs( urg[i+2].r-urg[i].r )< urg[i].r*0.05)||(fabs( urg[i+2].r-urg[i].r )< 0.05)){
		points[clnum].r[ptnum]=urg[i].r;
		points[clnum].thita[ptnum]=urg[i].thita;
		points[clnum].x[ptnum]=urg[i].x;
		points[clnum].y[ptnum]=urg[i].y;
		points[clnum].ptnum=ptnum;
		ptnum++;
		i++;
	    }    
	}

	else{
	    points[clnum].thita[ptnum]=urg[i].thita;
	    points[clnum].x[ptnum]=urg[i].x;
	    points[clnum].y[ptnum]=urg[i].y;
	    points[clnum].ptnum=ptnum;
	    ptnum++;

	    i++;
	    clnum++;
	    ptnum=0;
	    points[clnum].r[ptnum]=urg[i].r;
	    points[clnum].thita[ptnum]=urg[i].thita;
	    points[clnum].x[ptnum]=urg[i].x;
	    points[clnum].y[ptnum]=urg[i].y;
	    points[clnum].ptnum=ptnum;
	    ptnum++;
	}
    }

    clend=clnum;
  
    double x_sum,y_sum,r_sum;
    int sum;
    for(i=0;i<clend;i++){
	x_sum=0;
	y_sum=0;
	r_sum=0;
	sum=0;
	for(j=0;j<points[i].ptnum;j++){
	    x=points[i].x[j];
	    y=points[i].y[j];
	    r=points[i].r[j];
	    if(r!=0){
		x_sum+=x;
		y_sum+=y;
		r_sum+=r;
		sum++;
	    }
	}
	points[i].x_ave=x_sum/sum;
	points[i].y_ave=y_sum/sum;
	points[i].r_ave=r_sum/sum;    
    }

    
    
       double dis=0;
    double x0,y0,x1,y1,l,thita;
     dis=0;
    double clust_dis=0;
  
    for(i=0;i<clend;i++){
	dis=0;
	clust_dis=0;
	for(j=0;j<points[i].ptnum;j++){
	    if((fabs( points[i].r[j+1]-points[i].r[j] )< points[i].r[j]*0.10)||(fabs( points[i].r[j+1]-points[i].r[j] )< 0.10)){
		x0=points[i].x[j];
		y0=points[i].y[j];
		x1=points[i].x[j+1];
		y1=points[i].y[j+1];
		if((x0!=0)&&(y1!=0)){
		    dis=(x1-x0)*(x1-x0)+(y1-y0)*(y1-y0);
		    clust_dis+=dis;
		}
	    }
	}

	points[i].dis=clust_dis;
    }

	
    for(i=0;i<clend;i++){
	for(j=0;j<points[i].ptnum;j++){
	    clust_dis=points[i].dis;
	    //	    if((clust_dis<SizeMax)&&(clust_dis>SizeMin)){
	    if(clust_dis>SizeMax){
		points[i].flag2=0;
	    }
	}
    }
    

    for(i=0;i<clend;i++){
	ptnum=points[i].ptnum;
	if(ptnum<3) points[i].flag2=0;
    }

    int num=0;
    int min_num=0;
    double min_dis=10.0;
    double leng=LENGTH*LENGTH;
   dis=0;

    if(id_flag==0){
	goal_urg_x=target_x;   
	goal_urg_y=target_y;

    }

    else if(id_flag==1){
	target_x=goal_urg_x;   
	target_y=goal_urg_y;

    }

    for(i=0;i<clend;i++){
	{
	    target[num].x=points[i].x_ave;
	    target[num].y=points[i].y_ave;
	    target[num].r=points[i].r_ave;
	    target[num].i=i;
	    num++;
	}
    }

    target_num=num;
    
    for(i=0;i<target_num;i++){
	x=target[i].x;
	y=target[i].y;
	dis=(x-target_x)*(x-target_x)+(y-target_y)*(y-target_y);
	//	dis=sqrt(dis);
	target[i].dis=dis;
    }

    for(i=0;i<target_num;i++){
	if(points[i].flag2!=0){
	dis=target[i].dis;
       	if(min_dis>dis)
	    {
		min_dis=dis;
		min_num=i;
	    }
    }
}
    if(target[min_num].dis<leng){
	target_x=target[min_num].x;    
	target_y=target[min_num].y;
	points[min_num].flag=1;
	}


	target_pnum=0;
	obstacle_num=0;

  for(int i=0;i<lrf_scanpoint;i++){
		target_px[i]=0;
		target_py[i]=0; 
		obstacle_x[i]=0;
		obstacle_y[i]=0;
	}


  for(int i=0;i<clend;i++){
	for(int j=0;j<points[i].ptnum;j++){
	    x=points[i].x[j];
	   	y=points[i].y[j];

	if(points[i].flag==1){
		target_px[target_pnum]=x;
		target_py[target_pnum]=y; 
		target_pnum++;
	}
	else if(points[i].flag==0){
	if((fabs(x-target_x)>OBSTACLE_AREA)||(fabs(y-target_y)>OBSTACLE_AREA)){
		obstacle_x[obstacle_num]=x;
		obstacle_y[obstacle_num]=y;
		obstacle_num++;
	}
	else{
		target_px[target_pnum]=x;
		target_py[target_pnum]=y; 
		target_pnum++;
		}
	}
	}
    }


}






