/*!
 * @brief Obstacle module
 * $Date$
 * @author Nemoto,Mizoguchi lab,Tokyo University of Science
 * @mail:j7507640@ed.noda.tus.ac.jp
 * $Id$
 */


#include "type.h"
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>




class Graphics{

private:
//	static double goal_urg_x;
//	static double goal_urg_y;
//	static bool id_flag;


    static double px1[NUMBER],py1[NUMBER];
    static double px2[NUMBER],py2[NUMBER];
	static int p1num,p2num;

    static double xx[NUMBER],yy[NUMBER];
    static void display();
    static void idle(void);
    static void myInit(char *progname);
    static void myMouse( int button, int state, int x, int y );
	static void myMotion( int x, int y );
	static void mySkey( int key, int x, int y );
	static void myKbd( unsigned char key, int x, int y );
	static void resetview( void );
    static void reshape(int ,int);
    static void draw();
	static void polarview( void );
    static void* start_gui(void *);
    static int GUImain();
    void gui_start();
    void gui_end();

    SDL_Thread *th1;
	static int POINTS;


public:
	double CYCLE;
	int point;
	double resolusion;
	double offset;
	double zero_pos;
    Graphics();
    virtual ~Graphics();
    double timer_ms();

	void SetLRF(int Pnum,double *px,double *py);
	void SetObstacle(int Pnum,double *px,double *py);
	void SetObject(int Pnum,double *px,double *py);
	void SetObjectXY(double px,double py);
	void Input(bool& id,double &goal_x,double &goal_y);
};




